(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2013-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_universe.ml,v 1.4 2014-01-06 13:53:09 fclement Exp $*)

(* Numbering matrix slots. *)

module Hashtbl = Umatrix_hashtbl;;

type size = Hashtbl.size;;
type element = Hashtbl.key;;
type index = Hashtbl.value;;

type t =
  {
   tables : Hashtbl.t;
   cardinal : Upervasives.length;
  }
;;

(* Construction function. *)

let make sz =
  let mh = Hashtbl.make sz in
  { tables = mh; cardinal = Hashtbl.length mh; }
;;

(* Access functions. *)

let cardinal mu = mu.cardinal;;

let size mu = Hashtbl.size mu.tables;;

let index mu = Hashtbl.value_of_key mu.tables;;

let element mu = Hashtbl.key_of_value mu.tables;;

let sub_elements mu = Array.map (element mu);;
